#include <stdio.h>
#include <stdlib.h>
#include "mdprocess.h"

int processCount;

int main(int argc, char* argv[])
{
    int i;
    printf("Allgemeine Systeminformationen:\n");
    printf("\tProzessorleistung : %f GHz\n", mdclock());
    printf("\tArbeitsspeicher   : %d KB\n", mdram());
    printf("\tSpeicherauslastung: %d KB\n", mdusedram());
    mdsleep(2000,0);

    for (i = 1; i <= 10; i++)//schleife:;
    {
       processCount = mdplist();
       printf("Es laufen %d Prozesse\n", processCount);
       printf("CPU-Last: %d%%\n", mdcpu());
       printf("%s - PID: %d - %d RAM - %d%%\n", mdpnam(processCount), mdpid(processCount),
           mdpram(processCount), mdpcpu(processCount));
           
           mdsleep(800,1);
    }
    
    printf("%d", mdpkill(mdpid(processCount)));
    printf("Der letzte Prozess wurde beendet - wahrscheinlich war das sogar dieser ;)");
    
	return EXIT_SUCCESS;		
}