Declare Function mdplist Cdecl Lib "mdprocess" Alias "mdplist" () As Integer
Declare Function mdpram Cdecl Lib "mdprocess" Alias "mdpram" (processnumber As Integer) As Integer
Declare Function mdram Cdecl Lib "mdprocess" Alias "mdram" () As Integer
Declare Function mdpcpu Cdecl Lib "mdprocess" Alias "mdpcpu" (processnumber As Integer) As Integer
Declare Function mdcpu Cdecl Lib "mdprocess" Alias "mdcpu" () As Integer
Declare Function mdclock Cdecl Lib "mdprocess" Alias "mdclock" () As Single
Declare Function mdpnam Cdecl Lib "mdprocess" Alias "mdpnam" (processnumber As Integer) As ZString Ptr
Declare Function mdpid Cdecl Lib "mdprocess" Alias "mdpid" (processnumber As Integer) As Integer
Declare Function mdusedram Cdecl Lib "mdprocess" Alias "mdusedram" () As Integer
Declare Function mdsleep Cdecl Lib "mdprocess" Alias "mdsleep" (milliseconds As Integer, flag As Integer) As Integer
Declare Function mdpkill Cdecl Lib "mdprocess" Alias "mdpkill" (pid As Integer) As Integer

#Define IDR_VERSION1            1

Type processinfo_type
	nam As ZString*30
	pid As Integer
	cpu As Integer
	ram As Integer
End Type

#Include Once "windows.bi"
#Include Once "win/psapi.bi"
#Include Once "win/tlhelp32.bi"
#Include Once "win/imagehlp.bi"

Declare Function ProcessFirst Lib "kernel32" Alias "Process32First" (ByVal hSnapShot As HANDLE, uProcess As PROCESSENTRY32) As Long
Declare Function ProcessNext Lib "kernel32" Alias "Process32Next" (ByVal hSnapShot As HANDLE, uProcess As PROCESSENTRY32) As Long

Dim Shared As Longint sys, last_idleTime, last_kernelTime, last_userTime, last_kernelTime2(), last_userTime2()
Dim Shared As ZString Ptr pnam
Dim Shared As processinfo_type processinfo()
Dim Shared As Long z_alt


Function mdplist Cdecl () As Integer Export
   Dim As HANDLE hSnapShot
   Dim As Long Result, zaehler
   Dim As PROCESSENTRY32 Process
   
	zaehler = 0
   hSnapShot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, null)
	
   Process.dwSize = Len(Process)
   Result = ProcessFirst(hSnapShot, Process)
	
   Do While Result <> 0
 	   zaehler += 1
 	   If z_alt < zaehler Then ReDim Preserve processinfo(zaehler+1), last_kernelTime2(zaehler), last_userTime2(zaehler)
 	   pnam = StrPtr(Process.szExeFile)
      processinfo(zaehler).pid = Process.th32ProcessID
      processinfo(zaehler).nam = *pnam
      
      Result = ProcessNext(hSnapShot, Process)
   Loop
   CloseHandle(hSnapShot)
   z_alt = zaehler
   Return zaehler
End Function
Function mdpram Cdecl (processnumber As Integer) As Integer Export
	Dim As PROCESS_MEMORY_COUNTERS pmc
	Dim As Long infos
	Dim As HANDLE hProcess
	
	hProcess = OpenProcess(PROCESS_QUERY_INFORMATION, FALSE, processinfo(processnumber).pid)
	infos = GetProcessMemoryInfo(hProcess, @pmc, SizeOf(pmc))
   processinfo(processnumber).ram = (pmc.WorkingSetSize/1024)
	CloseHandle(hProcess)
	Return processinfo(processnumber).ram
End Function
Function mdram Cdecl () As Integer Export
	Dim lpBuffer AS MEMORYSTATUSEX
	
	lpBuffer.dwLength = SizeOf(MEMORYSTATUSEX)
	GlobalMemoryStatusEx (@lpBuffer)
	Return (lpBuffer.ullTotalPhys/1024)
End Function
Function mdpcpu Cdecl (processnumber As Integer) As Integer Export
	Dim As FILETIME creationTime2, exitTime2, kernelTime2, userTime2
	Dim As Longint Ptr pkernelTime2, puserTime2
	Dim As Longint res2, usr2, ker2, sys2
	Dim As HANDLE hProcess
	
	
	hProcess = OpenProcess(PROCESS_QUERY_INFORMATION, FALSE, processinfo(processnumber).pid)
	
   res2 = GetProcessTimes(hProcess, @creationTime2, @exitTime2, @kernelTime2, @userTime2)
   puserTime2 = CPtr(Longint Ptr, @userTime2)
   pkernelTime2 = CPtr(LongInt Ptr, @kernelTime2)
	
   usr2 = *puserTime2 - last_userTime2(processnumber)
   ker2 = *pkernelTime2 - last_kernelTime2(processnumber)
	
   sys2 = ker2 + usr2
	
   processinfo(processnumber).cpu = sys2 *100 / sys
   If processinfo(processnumber).cpu < 0 Then processinfo(processnumber).cpu = 0
   last_userTime2(processnumber) = *puserTime2
   last_kernelTime2(processnumber) = *pkernelTime2
	
	CloseHandle(hProcess)
	Return processinfo(processnumber).cpu
End Function
Function mdcpu Cdecl () As Integer Export
	Dim As FILETIME idleTime, kernelTime, userTime
	Dim As Longint Ptr pidleTime, pkernelTime, puserTime
	Dim As Longint res, usr, ker, idl
	Dim As Integer cpu_g
	
   res = GetSystemTimes(@idleTime, @kernelTime, @userTime)
   puserTime = CPtr(Longint Ptr, @userTime)
   pkernelTime = CPtr(Longint Ptr, @kernelTime)
   pidleTime = CPtr(Longint Ptr, @idleTime)
	
   usr = *puserTime - last_userTime
   ker = *pkernelTime - last_kernelTime
   idl = *pidleTime - last_idleTime
	
   sys = ker + usr
   cpu_g = (sys - idl) *100 / sys
	If cpu_g < 0 Then cpu_g = 0
   last_userTime = *puserTime
   last_kernelTime = *pkernelTime
   last_idleTime = *pidleTime
	Return cpu_g
End Function
Function mdclock Cdecl () As Single Export
	Dim As Uinteger t
	Dim As Double t1
	Dim As Integer cput
	
	Asm
		xor eax, eax
		rdtsc
		mov [t], eax
	End Asm
	t1 = Timer + 0.01
	Do:Loop Until t1 < Timer
	Asm
		xor eax, eax
		rdtsc
		Sub eax, [t]
		mov ecx, 100000
		cdq
		idiv ecx
		mov [cput], eax
	End Asm
	Return cput/100
End Function
Function mdpnam Cdecl (processnumber As Integer) As ZString Ptr Export
	Return @processinfo(processnumber).nam
End Function
Function mdpid Cdecl (processnumber As Integer) As Integer Export
	Return processinfo(processnumber).pid
End Function
Function mdusedram Cdecl () As Integer Export
	Dim lpBuffer AS MEMORYSTATUSEX
	
	lpBuffer.dwLength = SizeOf(MEMORYSTATUSEX)
	GlobalMemoryStatusEx (@lpBuffer)
	Return ((lpBuffer.ullTotalPhys/1024)-(lpBuffer.ullAvailPhys/1024))
End Function
Function mdsleep Cdecl (milliseconds As Integer, flag As Integer) As Integer Export
	Sleep milliseconds, flag
	Return 1
End Function
Function mdpkill Cdecl (pid As Integer) As Integer Export
	If TerminateProcess(OpenProcess(PROCESS_ALL_ACCESS, FALSE, pid), 0) = 0 Then
		Return 0
	Else
		Return 1
	EndIf
End Function






